## database gems
require 'dm-core'
require 'dm-types'
require 'dm-validations'

## Store class (DataMapper Resource)
module Sinatra
	module Backstage
		module User
			class User

				include DataMapper::Resource

				## Properties
				property :id, Serial
				property :username, String
				property :password, BCryptHash,
					:required => true
				# property :salt, BCryptHash,
				# 	:required => true,
				# 	:default => lambda {|r, p| BCrypt::Engine.generate_salt }

				# def salt
				# 	self.salt = BCrypt::Engine.generate_salt if super.nil?
				# end

				# def password=(new_password)
				# 	# self.password_hash = generate_salt_hash(new_password)
				# 	self.password_hash = new_password
				# end
				property :role, Enum[:anon, :user],
					:required => true,
					:default => :anon

				def session
					# generate_salt_hash(username)
					BCrypt::Engine.hash_secret(username, password)
				end

				## Methods
				# def generate_salt_hash(check_password)
				# 	BCrypt::Engine.hash_secret(check_password, salt)
				# end

			end
		end
	end
end